# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['tikon',
 'tikon.calibrador',
 'tikon.central',
 'tikon.datos',
 'tikon.ecs',
 'tikon.ecs.dists',
 'tikon.ejemplos',
 'tikon.ejemplos.calibs',
 'tikon.ejemplos.datos',
 'tikon.ejemplos.datos.Perera et al 1988',
 'tikon.ejemplos.proyectos',
 'tikon.ejemplos.proyectos.leucoptera_coffeella',
 'tikon.ejemplos.proyectos.opisina_arenosella',
 'tikon.móds',
 'tikon.móds.apli',
 'tikon.móds.apli.ecs',
 'tikon.móds.apli.ecs.descomp',
 'tikon.móds.apli.ecs.mrtld',
 'tikon.móds.clima',
 'tikon.móds.cultivo',
 'tikon.móds.cultivo.mod_pcse',
 'tikon.móds.manejo',
 'tikon.móds.rae',
 'tikon.móds.rae.orgs',
 'tikon.móds.rae.orgs.ecs',
 'tikon.móds.rae.orgs.ecs.crec',
 'tikon.móds.rae.orgs.ecs.crec.ec',
 'tikon.móds.rae.orgs.ecs.crec.tasa',
 'tikon.móds.rae.orgs.ecs.depred',
 'tikon.móds.rae.orgs.ecs.edad',
 'tikon.móds.rae.orgs.ecs.estoc',
 'tikon.móds.rae.orgs.ecs.mov',
 'tikon.móds.rae.orgs.ecs.mov.atr',
 'tikon.móds.rae.orgs.ecs.mov.dstn',
 'tikon.móds.rae.orgs.ecs.muertes',
 'tikon.móds.rae.orgs.ecs.repr',
 'tikon.móds.rae.orgs.ecs.trans',
 'tikon.móds.rae.orgs.ecs.trans.deter',
 'tikon.móds.rae.orgs.ecs.trans.mult',
 'tikon.móds.rae.orgs.ecs.trans.prob',
 'tikon.móds.rae.orgs.insectos',
 'tikon.móds.rae.orgs.plantas',
 'tikon.móds.rae.red',
 'tikon.móds.rae.red.res',
 'tikon.móds.trampa',
 'tikon.móds.trampa.ecs',
 'tikon.móds.trampa.ecs.captura',
 'tikon.móds.trampa.ecs.descomp']

package_data = \
{'': ['*'],
 'tikon.ejemplos.calibs': ['Opisina arenosella, Perera et al. 1988/*',
                           'Opisina arenosella, Perera et al. 1988/red/*']}

install_requires = \
['Babel>=2.9.1,<3.0.0',
 'PCSE>=5.5.0,<6.0.0',
 'Pillow>=9.0.1,<10.0.0',
 'SALib>=1.4.5,<2.0.0',
 'Shapely>=1.8.1,<2.0.0',
 'bibtexparser>=1.2.0,<2.0.0',
 'ennikkai>=1.2.5,<2.0.0',
 'frozendict>=2.3.4,<3.0.0',
 'geopy>=2.2.0,<3.0.0',
 'matplotlib>=3.5.1,<4.0.0',
 'numpy>=1.22.3,<2.0.0',
 'openpyxl>=3.0.10,<4.0.0',
 'pandas>=1.4.1,<2.0.0',
 'pyproj>=3.3.0,<4.0.0',
 'pyshp>=2.2.0,<3.0.0',
 'scipy>=1.8.0,<2.0.0',
 'seaborn>=0.11.2,<0.12.0',
 'spotpy>=1.5.14,<2.0.0',
 'taqdir>=2.1.3,<3.0.0',
 'tradssat>=0.1.7,<0.2.0',
 'xarray>=2022.3.0,<2023.0.0',
 'xlrd==1.2.0']

setup_kwargs = {
    'name': 'tikon',
    'version': '3.0.0',
    'description': 'Modelos de redes agroecológicas',
    'long_description': None,
    'author': 'Julien Jean Malard-Adam',
    'author_email': 'julien.malard@mail.mcgill.ca',
    'maintainer': None,
    'maintainer_email': None,
    'url': None,
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'python_requires': '>=3.9,<3.11',
}


setup(**setup_kwargs)
